import TurtleGraphics.*;
import java.awt.Color;

public class SmilingFace {

   private StandardPen pen;
   private double xPosition, yPosition;

   public SmilingFace(){
      xPosition = 0;
      yPosition = 0;
      pen = new StandardPen();
      pen.setColor(Color.red);
   }

   public SmilingFace(double x, double y){
      this();          
      xPosition = x;
      yPosition = y;
   }

   public void draw(){
      double radius = 50.0;
      
      // Draw the outline of the face
      drawCircle(xPosition, yPosition, radius);
      
      // Draw the left, then the right, eye.
      drawCircle(xPosition - radius / 2.5, yPosition + radius / 3, radius / 4);
      drawCircle(xPosition + radius / 2.5, yPosition + radius / 3, radius / 4);
      
      // Draw the horizontal part of the mouth
      drawLine(xPosition - radius / 3, yPosition - radius / 2,
               xPosition + radius / 3, yPosition - radius / 2);
               
      // Draw the left smile line         
      drawLine(xPosition - radius / 3    , yPosition - radius / 2,
               xPosition - radius / 3 - 5, yPosition - radius / 2 + 5);
               
      // Draw the right smile line         
      drawLine(xPosition + radius / 3    , yPosition - radius / 2,
               xPosition + radius / 3 + 5, yPosition - radius / 2 + 5);
   }

   public void erase(){
      pen.setColor(Color.white);
      draw();
      pen.setColor(Color.red);
   }
   
   
   public void move(double x, double y){
      xPosition = x;
      yPosition = y;
   }                   

   private void drawCircle(double x, double y, double r){
      double side = 2.0 * Math.PI * r / 120.0;
      pen.up();
      pen.move(x + r, y - side / 2.0);
      pen.setDirection(90);
      pen.down();
      for (int i = 0; i < 120; i++){
         pen.move(side);
         pen.turn(3);
      }
   }

   private void drawLine(double x1, double y1, double x2, double y2){
      pen.up();
      pen.move(x1, y1);
      pen.down();
      pen.move(x2, y2);
   }
}
